//lInfo=new Logger ("wesco_debug.log");
var cloudService = {
    makePostCall:function(sUrl,queryString,data) {
        //lInfo.logln("http post reuqest " + sUrl);
        //lInfo.logln("             body " + data);
        try {

        	var handle = new WebserviceConnection();
        	//lInfo.logln("making new post " + sUrl + ' with data ' + data);
            if (this.isNewWebrequest()) {
		    	handle.request(sUrl,queryString, 'POST', {'Content-Type':'application/json','NotificationTextIsUrlEncodedUtf7':'true'},
		    		data ,true, function(code, retdata) {
                        if (code === 200) {
                            //lInfo.logln( ': OK [' + code + ']');
                        } else {
                            //lWarn.logln(': FAILED! Server replied: "' + code + '"');
                        }
                        //lInfo.logln(': body [' + retdata + ']');
                });
            } else {
            	handle.request(sUrl + '?' + queryString + '&token=' + this.getOSPToken(),
            		'POST', {'Content-Type':'application/json','NotificationTextIsUrlEncodedUtf7':'true'},
        			data, function(code, retdata) {
        				if (code === 200) {
                            //lInfo.logln( ': OK [' + code + ']');
                        } else {
                            //lWarn.logln(': FAILED! Server replied: "' + code + '"');
                        }
                        //lInfo.logln(': body [' + retdata + ']');
        			});
            }
            return;
        } catch (e) {
            //lWarn.logln("Exception during http post reuqest " + sUrl+": ");
            for (var i in e) {
                //lWarn.logln(i + ': ' + e[i]);
            }
        }
        return;
    },
    makeGetCall:function(sFunction,queryString,func) {
        //lInfo.logln("http get reuqest " + sFunction);
        try {
            var handle = new WebserviceConnection();
            if (this.isNewWebrequest()) {
                handle.simplerequest(sFunction,queryString, 'GET', true ,function(code, data) {
                     if (code === 200) {
                        //lInfo.logln( ': OK [' + code + ']');
                    } else {
                        //lWarn.logln(': FAILED! Server replied: "' + code + '"');
                    }
                    //lInfo.logln(': body [' + data + ']');
		    func(JSON.parse(data));
                });
            } else {
		        handle.simplerequest(sFunction+'?' + queryString + '&token=' + this.getOSPToken(),
		        	'GET', function(code, data) {
		            if (code === 200) {
		                //lInfo.logln( ': OK [' + code + ']');
		            } else {
		                //lInfo.logln(': FAILED! Server replied: "' + code + '"');
		            }
		            //lInfo.logln(data);
		            func(JSON.parse(data));
		        });
            }
            return;
        } catch (e) {
            //lWarn.logln("Error during upload: ");
            for (var i in e) {
                //lWarn.logln(i + ': ' + e[i]);
            }
        }
        return;
    },
    isNewWebrequest:function() {
        return (Property.getNode('/scripts/system-addon-remote-connectivity') != null);
    },
    getOSPToken:function() {
        if (Property.getNode('/scripts/remote-connectivity/OSPToken') != null)
          return Property.getNode('/scripts/remote-connectivity/OSPToken').getValue();
        if (Property.getNode('/scripts/system-addon-remote-connectivity/OSPToken') != null)
          return Property.getNode('/scripts/system-addon-remote-connectivity/OSPToken').getValue();
        return null;
      },
    getCloudEmail:function() {
        if (Property.getNode('/scripts/remote-connectivity/username') != null)
            return Property.getNode('/scripts/remote-connectivity/username').getValue();
          if (Property.getNode('/scripts/system-addon-remote-connectivity/username') != null)
            return Property.getNode('/scripts/system-addon-remote-connectivity/username').getValue();
          return null;
    },
    getMyDSID:function(){
		return Property.getProperty('/system/dSID');
	},
    fetchNotificationList:function(func) {
    	//GetMobileApps
    	var url='/public/accessmanagement/v1_0/RemoteConnectivity/GetMobileApps';
    	var query='email='+ this.getCloudEmail();
    	this.makeGetCall(url,query,func);
    },
    sendNotification:function(uuida,text) {
    	var url='/public/notification/v1_0/SendNotification/SendPushNotification';
    	var query='notificationID=PUSH_NOTIFICATION_DSS_EVENT_PUSH&languageCode=de-DE';
    	var body='{"MobileAppUUIDList": [';
    	var fFirst=true;
    	for (var iIndex=0;iIndex<uuida.length;iIndex++) {
    		if (!fFirst)
    			body=body+',';
    		body=body+'"' + uuida[iIndex] + '"';
    		fFirst=false;
    	}
    	body=body+'],"NotificationKeyValueList": { "Text": "'+text+'" } }';
    	this.makePostCall(url,query,body);
    }
};
